/*
 ============================================================================
 Project     : 1.5 Approximation Algorithm for sorting by reversals
 Author      : Jose Luis Soncco Alvarez and Mauricio Ayala Rincon
               Universidade de Brasilia (UnB) - Brazil
 Version     : 1.0
 
 Last Modified On: January 23, 2012.
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "breakpointGraph.h"

void montaGrafoBreakpoint(const permutacao *p, \
	breakpointGraph *b)
{
	int i;
	
	memset(b->nadjPreta, 0, sizeof(b->nadjPreta));
    memset(b->nadjCinza, 0, sizeof(b->nadjCinza));
    memset(b->adjPreta, 0, sizeof(b->adjPreta));
    memset(b->adjCinza, 0, sizeof(b->adjCinza));
	
	//Criar arestas pretas
	for(i=0;i<=p->tamanho;i++){ //tmanho no es +1 por que despues del ultimo no hay blacks
		if (abs(p->pi[i] - p->pi[i+1]) > 1){
			b->adjPreta[i][b->nadjPreta[i]] = i+1; 
			b->adjPreta[i+1][b->nadjPreta[i+1]] = i; 
			b->nadjPreta[i]++;
			b->nadjPreta[i+1]++;
		}			
	}
	
	//Criar arestas cinzas
	for(i=0;i<=p->tamanho;i++){ //tmanho no es +1 por que despues del ultimo en el invertido no hay grays
		if (abs(p->piInverso[i] - p->piInverso[i+1]) > 1){
			b->adjCinza[p->piInverso[i]][b->nadjCinza[p->piInverso[i]]] = p->piInverso[i+1]; 
			b->adjCinza[p->piInverso[i+1]][b->nadjCinza[p->piInverso[i+1]]] = p->piInverso[i]; 
			b->nadjCinza[p->piInverso[i]]++;
			b->nadjCinza[p->piInverso[i+1]]++;			
		}
	}
}

