/*
 ============================================================================
 Project     : 1.5 Approximation Algorithm for sorting by reversals
 Author      : Jose Luis Soncco Alvarez and Mauricio Ayala Rincon
                Universidade de Brasilia (UnB) - Brazil
 Version     : 1.0
 
 Last Modified On: January 23, 2012.
 ============================================================================
 */

#ifndef GRAFOS_H_
#define GRAFOS_H_

#define MAX 202 /**Numero maximo de vertices + 2**/

#define AZUL 0
#define VERMELHO 1

#define DESORIENTADA 0
#define ORIENTADA 1

#define PRETA 0
#define CINZA 1

typedef struct {  /*indices dos arranjos sao valores da permutacao*/
	int adj[MAX][MAX]; /**matriz de adjacencias**/
	int nadj[MAX]; /**numero de adj de cada no**/
	int cor[MAX]; /**cor dos vertices do grafo, azul  definido como 0 e vermelho como 1**/
	int componente[MAX]; /**indica o vertice lider de cada componente conexa**/
	int orientacaoComponente[MAX] /**orientacao da componente**/; /*?*/
	int tamanho; /**numero de vertices do grafo (indexados de 0 ate tamanho -1)**/
	int verticesIsolados; /**da o numero de vertices azuis isolados**/
}reversalGraph;

typedef struct { /*indices dos arranjos sao indices da permutacao*/
    int adjPreta[MAX][2]; /**matriz de adjacencia das arestas pretas**/
    int adjCinza[MAX][2]; /**matriz de adjacencia das arestas cinzas**/
    int nadjPreta[MAX]; /**numero de adjacencias pretas**/
    int nadjCinza[MAX]; /**numero de adjacencias cinzas**/      
} breakpointGraph;

typedef struct {
    //breakpointGraph *ciclo; // JP: estava com MAX, mas nao coube na pilha, entao 
                            //     vamos trabalhar com alocacao dinamica mesmo.  
    breakpointGraph ciclo[MAX];   
    int nCiclos;
}decomposicaoSemOrientacao;//Esto pasara a ser decomposicaoSemOrientacao

//*nueva estructura ****
typedef struct {
    //mudar arestaCinza a verticeAresta
    int arestaCinza[MAX][3]; //matriz relacionando aresta cinzas con pretas(Guarda valores y nao posicoes)
    //o indice representa o vertice  (a mesma aresta cinza)
    //coluna 1 representa o vertice+1 
    //coluna 2 representa a aresta preta relaciona con vertice
    //coluna 3 representa a aresta preta relaciona con vertice+1
}cicloOrientado;

//*nueva estructura ****
typedef struct {
    cicloOrientado ciclo[MAX];
    int nCiclos;
}decomposicaoCiclos;


typedef struct {
    int tamanho; /**tamanho da permutacao**/
    int pi[MAX]; /**permutacao**/
    int piInverso[MAX]; /**permutacao Inversa**/
}permutacao;

typedef struct{
	int esq;
	int dir;
}intervalo;

/**
p1<p2 e p3<p4 representam arestas pretas
c1<c2 e c3<c4 representam arestas cinzas

p1 nao e necessariamente menor que p3
c1 nao e necessariamente menor que c3
**/

typedef struct {
    int p1,p2,p3,p4;
    int c1,c2,c3,c4;
}ciclo2;

typedef struct{
	int* reversoes;
	intervalo* intervalos;
	int tamanho;
}reversals;

#endif
