/*
 ============================================================================
 Project     : Genetic algorithm for sorting by reversals with simple fitness function
 Author      : Jose Luis Soncco Alvarez and Mauricio Ayala Rincon
                Universidade de Brasilia (UnB) - Brazil
 
 Last Modified On: January 23, 2012.
 ============================================================================
 */

#ifndef ESTRUCTURAS_H_
#define ESTRUCTURAS_H_

#define NN 202 // Nro de elementos + 2
#define MAX_GENES 4*NN
#define MAX_POB 1546 //NLogN (log base 2)

typedef struct{
	int izq;
	int der;
}gen;

typedef struct{    
    int pi[NN]; /**permutacao**/
    int piInverso[NN]; /**permutacao Inversa**/
    int tamanho; /**tamanho da permutacao**/
}permutacion;

typedef struct{
	gen genes[MAX_GENES]; // 4*n (podria ser mas)
	int tamanho;//son el fitness
	int nroBreakpoints;//son el fitness
	int fitness;
	permutacion p;    		
}cromosoma;

typedef struct{
	cromosoma *cromosomas;
	int tamanho;
	int limiteCrossover;
	int limiteInferior;
	int limiteSuperior;	
}poblacion;

#endif
